# Copyright 2016 Jochen Fabricius
# Distribution and modification is encouraged

# various regularly used functions 

# print the message $msg to stderr of global variable $::Debug is set to true/1
proc DEBUGPRINT {msg} {
  if {$::Debug} {
    puts stderr "[lindex [info level -1] 0]: $msg"
  }
}

proc DEBUGPROCCALL {proc} {
  trace add execution $proc enter [list apply {{proc op} {
      for {set i [info level]} {$i > 0} {incr i -1} { 
        puts -nonewline stderr "[lindex [info level $i] 0] -> "
      }
      puts stderr $proc
    }
  }]
}

proc DEBUGVARSET {var} {
  trace add variable $var write [list apply {{v1 v2 op} {
      for {set i [info level]} {$i > 0} {incr i -1} { 
        puts -nonewline stderr "[lindex [info level $i] 0] -> "
      }
    }
  }]
}

